Project Chrono: chrono::vehicle::ChSprocket Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
chrono::vehicle::ChSprocket Class Referenceabstract
VEHICLE module » Tracked vehicles » Sprocket subsystem

## Description

Base class for a tracked vehicle sprocket.

A sprocket is responsible for contact processing with the track shoes of the containing track assembly.

`#include <ChSprocket.h>`

Inheritance diagram for chrono::vehicle::ChSprocket:
[legend]
Collaboration diagram for chrono::vehicle::ChSprocket:
[legend]

## Public Member Functions
virtual unsigned int | GetNumTeeth () const =0
| Get the number of teeth of the gear.
virtual double | GetAssemblyRadius () const =0
| Get the track assembly radius.
virtual double | GetAddendumRadius () const =0
| Get the addendum radius.
std::shared_ptr< ChBody > | GetGearBody () const
| Get a handle to the gear body.
std::shared_ptr< ChShaft > | GetAxle () const
| Get a handle to the axle shaft.
std::shared_ptr< ChLinkLockRevolute > | GetRevolute () const
| Get a handle to the revolute joint.
double | GetAxleSpeed () const
| Get the angular speed of the axle.
void | EnableCollision (bool val)
| Turn on/off collision flag for the gear wheel.
std::shared_ptr< ChContactMaterial > | GetContactMaterial () const
| Get the sprocket contact material.
void | DisableLateralContact ()
| Disable lateral contact for preventing detracking (default: enabled).
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, const ChVector3d &location, ChTrackAssembly *track)
| Initialize this sprocket subsystem.
void | ApplyAxleTorque (double torque)
| Apply the provided torque to the sprocket's axle (for debugging and testing).
std::shared_ptr< ChTriangleMeshConnected > | CreateVisualizationMesh (double radius, double width, double delta, ChColor color=ChColor(1, 1, 1)) const
| Utility function to create a sprocket visualization mesh.
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the sprocket subsystem.
virtual void | RemoveVisualizationAssets () override
| Remove visualization assets for the sprocket subsystem.
void | LogConstraintViolations ()
| Log current constraint violations.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
virtual std::string | GetTemplateName () const =0
| Get the name of the vehicle subsystem template.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Protected Member Functions
| ChSprocket (const std::string &name)
| Construct a sprocket subsystem with given name.
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual double | GetGearMass () const =0
| Return the mass of the gear body.
virtual const ChVector3d & | GetGearInertia ()=0
| Return the moments of inertia of the gear body.
virtual double | GetAxleInertia () const =0
| Return the inertia of the axle shaft.
virtual double | GetSeparation () const =0
| Return the distance between the two gear profiles.
virtual double | GetLateralBacklash () const =0
| Return the allowed backlash (play) before lateral contact with track shoes is enabled (to prevent detracking).
virtual std::shared_ptr< ChLinePath > | GetProfile () const =0
| Return the 2D gear profile.
virtual void | CreateContactMaterial (ChContactMethod contact_method)=0
| Create the contact material consistent with the specified contact method.
virtual std::shared_ptr< ChSystem::CustomCollisionCallback > | GetCollisionCallback (ChTrackAssembly *track)=0
| Return the custom collision callback object.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const override
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const override
| Output data for this subsystem's component list to the specified database.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Protected Attributes
ChVector3d | m_rel_loc
| sprocket subsystem location relative to chassis
std::shared_ptr< ChBody > | m_gear
| sprocket gear body
std::shared_ptr< ChShaft > | m_axle
| gear shafts
std::shared_ptr< ChShaftBodyRotation > | m_axle_to_spindle
| gear-shaft connector
std::shared_ptr< ChLinkLockRevolute > | m_revolute
| sprocket revolute joint
std::shared_ptr< ChContactMaterial > | m_material
| contact material;
std::shared_ptr< ChSystem::CustomCollisionCallback > | m_callback
| cached collision callback
bool | m_lateral_contact
| if 'true', enable lateral conatact to prevent detracking
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Friends
class | ChTrackAssembly

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Function Documentation

## ◆ AddVisualizationAssets()

void chrono::vehicle::ChSprocket::AddVisualizationAssets | ( | VisualizationType | vis | ) |
| overridevirtual

Add visualization assets for the sprocket subsystem.

Reimplemented from chrono::vehicle::ChPart.

Reimplemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, and chrono::vehicle::marder::Marder_SprocketSinglePin.

## ◆ ApplyAxleTorque()

void chrono::vehicle::ChSprocket::ApplyAxleTorque | ( | double | torque | ) |

Apply the provided torque to the sprocket's axle (for debugging and testing).

Note that this torque is added to any torque applied by the driveline. As such, this function should be called only after a call to the vehicle Synchronize function. A positive value corresponds to forward motion.

## ◆ CreateContactMaterial()

virtual void chrono::vehicle::ChSprocket::CreateContactMaterial | ( | ChContactMethod | contact_method | ) |
| protectedpure virtual

Create the contact material consistent with the specified contact method.

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, and chrono::vehicle::marder::Marder_SprocketSinglePin.

## ◆ CreateVisualizationMesh()

std::shared_ptr< ChTriangleMeshConnected > chrono::vehicle::ChSprocket::CreateVisualizationMesh | ( | double | radius,
|  | double | width,
|  | double | delta,
|  | ChColor | color = ChColor(1, 1, 1) ) const

Utility function to create a sprocket visualization mesh.

Parameters

  radius | inner radius
  width | gear width
  delta | arclength between points
  color | mesh color

## ◆ ExportComponentList()

void chrono::vehicle::ChSprocket::ExportComponentList | ( | rapidjson::Document & | jsonDocument | ) | const
| overrideprotectedvirtual

Export this subsystem's component list to the specified JSON object.

Reimplemented from chrono::vehicle::ChPart.

## ◆ GetAddendumRadius()

virtual double chrono::vehicle::ChSprocket::GetAddendumRadius | ( |  | ) | const
| pure virtual

Get the addendum radius.

This quantity is an average radius for sprocket-track engagement used to estimate longitudinal slip.

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, chrono::vehicle::marder::Marder_SprocketSinglePin, chrono::vehicle::SprocketBand, chrono::vehicle::SprocketDoublePin, and chrono::vehicle::SprocketSinglePin.

## ◆ GetAssemblyRadius()

virtual double chrono::vehicle::ChSprocket::GetAssemblyRadius | ( |  | ) | const
| pure virtual

Get the track assembly radius.

This quantity is used during the automatic track assembly. It represents a safe distance from the sprocket gear center at which the track shoes can be instantiated.

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, chrono::vehicle::marder::Marder_SprocketSinglePin, chrono::vehicle::SprocketBand, chrono::vehicle::SprocketDoublePin, and chrono::vehicle::SprocketSinglePin.

## ◆ GetAxleInertia()

virtual double chrono::vehicle::ChSprocket::GetAxleInertia | ( |  | ) | const
| protectedpure virtual

Return the inertia of the axle shaft.

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, chrono::vehicle::marder::Marder_SprocketSinglePin, chrono::vehicle::SprocketBand, chrono::vehicle::SprocketDoublePin, and chrono::vehicle::SprocketSinglePin.

## ◆ GetCollisionCallback()

virtual std::shared_ptr< ChSystem::CustomCollisionCallback > chrono::vehicle::ChSprocket::GetCollisionCallback | ( | ChTrackAssembly * | track | ) |
| protectedpure virtual

Return the custom collision callback object.

Parameters

  [in] | track | pointer to containing track assembly

Implemented in chrono::vehicle::ChSprocketBand, chrono::vehicle::ChSprocketDoublePin, and chrono::vehicle::ChSprocketSinglePin.

## ◆ GetGearInertia()

virtual const ChVector3d & chrono::vehicle::ChSprocket::GetGearInertia | ( |  | ) |
| protectedpure virtual

Return the moments of inertia of the gear body.

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, chrono::vehicle::marder::Marder_SprocketSinglePin, chrono::vehicle::SprocketBand, chrono::vehicle::SprocketDoublePin, and chrono::vehicle::SprocketSinglePin.

## ◆ GetGearMass()

virtual double chrono::vehicle::ChSprocket::GetGearMass | ( |  | ) | const
| protectedpure virtual

Return the mass of the gear body.

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, chrono::vehicle::marder::Marder_SprocketSinglePin, chrono::vehicle::SprocketBand, chrono::vehicle::SprocketDoublePin, and chrono::vehicle::SprocketSinglePin.

## ◆ GetLateralBacklash()

virtual double chrono::vehicle::ChSprocket::GetLateralBacklash | ( |  | ) | const
| protectedpure virtual

Return the allowed backlash (play) before lateral contact with track shoes is enabled (to prevent detracking).

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, chrono::vehicle::marder::Marder_SprocketSinglePin, chrono::vehicle::SprocketBand, chrono::vehicle::SprocketDoublePin, and chrono::vehicle::SprocketSinglePin.

## ◆ GetNumTeeth()

virtual unsigned int chrono::vehicle::ChSprocket::GetNumTeeth | ( |  | ) | const
| pure virtual

Get the number of teeth of the gear.

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, chrono::vehicle::marder::Marder_SprocketSinglePin, chrono::vehicle::SprocketBand, chrono::vehicle::SprocketDoublePin, and chrono::vehicle::SprocketSinglePin.

## ◆ GetProfile()

virtual std::shared_ptr< ChLinePath > chrono::vehicle::ChSprocket::GetProfile | ( |  | ) | const
| protectedpure virtual

Return the 2D gear profile.

The gear profile, a ChLinePath geometric object, is made up of an arbitrary number of sub-paths of type ChLineArc or ChLineSegment sub-lines. These must be added in clockwise order, and the end of sub-path i must be coincident with beginning of sub-path i+1.

Implemented in chrono::vehicle::ChSprocketBand, chrono::vehicle::ChSprocketDoublePin, and chrono::vehicle::ChSprocketSinglePin.

## ◆ GetSeparation()

virtual double chrono::vehicle::ChSprocket::GetSeparation | ( |  | ) | const
| protectedpure virtual

Return the distance between the two gear profiles.

Implemented in chrono::vehicle::m113::M113_SprocketBand, chrono::vehicle::m113::M113_SprocketDoublePin, chrono::vehicle::m113::M113_SprocketSinglePin, chrono::vehicle::marder::Marder_SprocketSinglePin, chrono::vehicle::SprocketBand, chrono::vehicle::SprocketDoublePin, and chrono::vehicle::SprocketSinglePin.

## ◆ Initialize()

void chrono::vehicle::ChSprocket::Initialize | ( | std::shared_ptr< ChChassis > | chassis,
|  | const ChVector3d & | location,
|  | ChTrackAssembly * | track )
| virtual

Initialize this sprocket subsystem.

The sprocket subsystem is initialized by attaching it to the specified chassis body at the specified location (with respect to and expressed in the reference frame of the chassis).

Parameters

  [in] | chassis | associated chassis
  [in] | location | location relative to the chassis frame
  [in] | track | pointer to containing track assembly

## ◆ InitializeInertiaProperties()

void chrono::vehicle::ChSprocket::InitializeInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Initialize subsystem inertia properties.

Derived classes must override this function and set the subsystem mass (m_mass) and, if constant, the subsystem COM frame and its inertia tensor. This function is called during initialization of the vehicle system.

Implements chrono::vehicle::ChPart.

## ◆ Output()

void chrono::vehicle::ChSprocket::Output | ( | ChVehicleOutput & | database | ) | const
| overrideprotectedvirtual

Output data for this subsystem's component list to the specified database.

Reimplemented from chrono::vehicle::ChPart.

## ◆ RemoveVisualizationAssets()

void chrono::vehicle::ChSprocket::RemoveVisualizationAssets | ( |  | ) |
| overridevirtual

Remove visualization assets for the sprocket subsystem.

Reimplemented from chrono::vehicle::ChPart.

## ◆ UpdateInertiaProperties()

void chrono::vehicle::ChSprocket::UpdateInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Update subsystem inertia properties.

Derived classes must override this function and set the global subsystem transform (m_xform) and, unless constant, the subsystem COM frame (m_com) and its inertia tensor (m_inertia). Calculate the current inertia properties and global frame of this subsystem. This function is called every time the state of the vehicle system is advanced in time.

Implements chrono::vehicle::ChPart.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/ChSprocket.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/ChSprocket.cpp